Program Launcher;
Uses Windows, Kol;
{$APPTYPE GUI}
{$D-}
Var
   Ini: PIniFile;        // Class for .ini file
   PSrc, PDest,          // Source and Destination of files to be copied
   Name,                 // Name of parameter in .ini
   Files,                // Names of  files to be copied separeted by ";"
   Run,                  // File to be executed. Command line parameters will be copied to apllication.
   Aux:  String;         // Temp var
   List: PStrList;       // List of parameters in a section of .ini
   C:    Integer;        // Counter of parameters

// Verify if exist $P in Path and replace with "Program Files" path.

function ParsePath(Path: String): String;
Var
   Aux: String;
   Index: Integer;
   Key: HKey;
   DataType: Integer;
   BuffSize: Integer;
begin
  // test $P in Path
  Index := Pos('$P',Path);
  If Index > 0 Then
  Begin
    // Open Registry and get Program files dir in local language
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'Software\Microsoft\Windows\CurrentVersion', 0, KEY_READ, Key) = ERROR_SUCCESS Then
    Begin
         SetLength(Aux, 255);
         ZeroMemory(@Aux[1], 255);
         DataType := REG_SZ;
         BuffSize := 255;
         If RegQueryValueEx(Key, 'ProgramFilesDir', nil, @DataType, @Aux[1], @BuffSize) = ERROR_SUCCESS Then
            Aux := Trim(Copy(Aux, 1, BuffSize));
         RegCloseKey( Key );
    End;
    Result := Aux + Copy(Path, Index + 2, 255);
  End
  Else
      Result := Path;
end;

// Get file time creation
function FileAge( const Path : String ) : TFileTime;
var FD : TWin32FindData;
    FH : THandle;
begin
  FH := FindFirstFile( PChar( Path ), FD );
  if FH = INVALID_HANDLE_VALUE then exit;
  Result := FD.ftLastWriteTime;
  FindClose( FH );
end;



begin
    Try
     List := NewStrList;
     // Get exe name
     Aux := ExtractFileName(ParamStr(0));
     // Get name and dot
     Aux := Copy(Aux,1, Pos('.',Aux));
     // Open ini file with the name of exe file
     Aux := ExtractFilePath(ParamStr(0))+ Aux + 'ini';
     // Open ini
     Ini := OpenIniFile(Aux);
     //Set section to work
     Ini.Section := 'Server';
     // Set mode of operation
     Ini.Mode := ifmRead;
     // Get section parameters
     List.Clear;
     Ini.SectionData(List);
     // Read Src, Dest and Run
     PSrc  := ParsePath(Ini.ValueString('Source',''));
     PDest := ParsePath(Ini.ValueString('Destination',''));
     Run   := Ini.ValueString('Run','');
     Files := '';
     // Loop to load FIlEs parameters
     For C:= 0 To List.Count -1 Do
     Begin
        // Get the name of parameter
         Aux := List.Items[C];
         Name := UpperCase(Trim(Copy(Aux, 1, Pos('=', Aux) - 1)));
         // Test if is FILExxx
         If Pos('FILE', Name) > 0 Then
         Begin
              // Get file name
              Aux := Ini.ValueString(Name,'');
              // Compare dates
              If CompareFileTime(FileAge(PSrc + Aux), FileAge(PDest + Aux)) <> 0 Then
              // Copy names to files
                 Files := Files + PSrc + Aux + ';';
         End;
     End;
     If Files <> '' Then
     Begin
        // Copy all files
        MessageBeep(0);
        CopyMoveFiles(Files, PDest, False);
     End;   
    Finally
     // Destroy objects
     Ini.Free;
     List.Free;
    End;
    // Test run
    If Run <> '' Then
    Begin
      // Get command line parameters
      Aux := '';
      For C:= 1 To ParamCount Do
          Aux :=  Aux + ParamStr(C) + ' ';
      Aux := PDest + Run + ' ' + Aux;
      // Exec Run with parameters
      WinExec(PChar(Aux), SW_SHOW);
    End;
end.
