unit win95;
{
 For copying, moving and erasing files like Windows 95 Explorer
 Date  : 06/04/97
 This update: 18/04/97
 Autor : Rafael Ribas Aguil (Brazil)
 e-mail: rribas@uninet.com.br

 I hope receive bugs corrections by all the people who asked me to send
 this source code. Thanks to all.

 I also hope to receive other funny functions !!!

 Now is necessary to give multiple names separated with a ';'.

 (18/04/97)
 Update with many tips and information sent by many people.
 Thanks to all.
}

interface
Uses ShellApi;

function Win95Copy(Owner: Integer;  FromFile,ToFile: String): Boolean;
function Win95Move(Owner: Integer;  FromFile,ToFile: String): Boolean;
function Win95Erase(Owner: Integer;  WichFiles: String): Boolean;

implementation

function Win95Copy(Owner: Integer; FromFile,ToFile: String): Boolean;
const
  Aborted: Boolean = False;
var
  Struct : TSHFileOpStructA;
begin
  {To allow multiple source files, replace spaces with #0}
  {Bug correction (17/04/97): multiple files with spaces in names didn't
   work. Now we need to give the names (FromFile) separated with a ';' .}

  While pos(';',FromFile)>0 do
    FromFile[pos(';',FromFile)]:=#0;
  While pos(';',ToFile)>0 do
    ToFile[pos(';',ToFile)]:=#0;
  {Bug correction on 13/04/97: Names must terminate with double nulls}
  FromFile:=FromFile+#0#0;
  ToFile:=ToFile+#0#0;
  with Struct do
    begin
      wnd         :=Owner;
      wFunc       :=FO_Copy;
      pFrom       :=@FromFile[1];
      pTo         :=@ToFile[1];
      {New changes here (18/04/97)}
      fFLags      :=FOF_NOCONFIRMMKDIR;
      fAnyOperationsAborted:=Aborted;
      hNameMappings:=nil;
      lpszProgressTitle:=nil;
    end;
  {New changes here (18/04/97)}
  Result:=(SHFileOperationA(Struct)=0) and (not Aborted);
end;

function Win95Move(Owner: Integer; FromFile,ToFile: String): Boolean;
const
  Aborted: Boolean = False;
var
  Struct : TSHFileOpStructA;
begin
  {To allow multiple source files, replace spaces with #0}
  {Bug correction (17/04/97): multiple files with spaces in names didn't
   work. Now we need to give the names (FromFile) separated with a ';' .}

  While pos(';',FromFile)>0 do
    FromFile[pos(';',FromFile)]:=#0;
  While pos(';',ToFile)>0 do
    ToFile[pos(';',ToFile)]:=#0;
  {Bug correction on 13/04/97: Names must terminate with double nulls}
  FromFile:=FromFile+#0#0;
  ToFile:=ToFile+#0#0;
  with Struct do
    begin
      wnd         :=Owner;
      wFunc       :=FO_Move;
      pFrom       :=@FromFile[1];
      pTo         :=@ToFile[1];
      {New changes here (18/04/97)}
      fFLags      :=FOF_ALLOWUNDO or FOF_CONFIRMMOUSE;
      fAnyOperationsAborted:=Aborted;
      hNameMappings:=nil;
      lpszProgressTitle:=nil;
    end;
  {New changes here (18/04/97)}
  Result:=(SHFileOperationA(Struct)=0) and (not Aborted);
end;

function Win95Erase(Owner: Integer;  WichFiles: String): Boolean;
const
  Aborted: Boolean = False;
var
  Struct : TSHFileOpStructA;
begin
  {Bug correction on 13/04/97: Names must terminate with double nulls}
  WichFiles:=WichFiles+#0#0;
  with Struct do
    begin
      wnd         :=Owner;
      wFunc       :=FO_Delete;
      pFrom       :=@WichFiles[1];
      pTo         :=nil;
      {New changes here (18/04/97)}
      fFLags      :=FOF_ALLOWUNDO or FOF_CONFIRMMOUSE;
      fAnyOperationsAborted:=Aborted;
      hNameMappings:=nil;
      lpszProgressTitle:=nil;
    end;
  {New changes here (18/04/97)}
  Result:=(SHFileOperationA(Struct)=0) and (not Aborted);
end;

end.
